package book;

/**
 * <h2>Double number.</h2>
 *
 * <p>This is like the java.lang.Double class but is mutable, the contained
 * value being changeable.</p>
 *
 * @author Antoine Dutot
 * @since 20040825
 */
public class DoubleNumber
	extends Number
{
// Attributes

	private static final long serialVersionUID = -7369345969598095468L;

	/**
	 * The double value.
	 */
	protected double value = 0.0;

// Constructors

	/**
	 * Double number initialized to 0.
	 */
	public
	DoubleNumber()
	{
	}

	/**
	 * Double number initialized to <code>value</code>.
	 * @param value The initial value.
	 */
	public
	DoubleNumber( double value )
	{
		this.value = value;
	}

// Accessors

	/**
	 * Value of this number.
	 */
	public double
	getValue()
	{
		return value;
	}

	public byte
	byteValue()
	{
		return (byte) value;
	}

	public double
	doubleValue()
	{
		return value;
	}

	public float
	floatValue()
	{
		return (float) value;
	}

	public int
	intValue()
	{
		return (int) value;
	}

	public long
	longValue()
	{
		return (long) value;
	}

	public short
	shortValue()
	{
		return (short) value;
	}

// Commands

	/**
	 * Change the value.
	 * @param value The new value.
	 */
	public void
	setValue( double value )
	{
		this.value = value;
	}
}
