package book;

/**
 * <h2>Thrown when a an object must stay without children but one was inserted.</h2>
 *
 * @author Antoine Dutot
 * @since 20030503
 */
public class LeafException
	extends RuntimeException
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 4222724586628957704L;

	/**
	 * Throws the message "child added in object that must stay without children".
	 */
	public
	LeafException()
	{
		super( "child added in object that must stay without children" );
	}

	/**
	 * Throws <code>message</code>.
	 * @param message The message to throw.
	 */
	public
	LeafException( String message )
	{
		super( message );
	}
}
