package book;

/**
 * <h2>Some math utilities.</h2>
 *
 * @author Antoine Dutot
 * @since 20040704
 */
public class MathUtils
{
	/**
	 * Closer power of two greater or equal to <code>i</code>.
	 * @param i The integer number for which the closer power of two is to be found.
	 * @return The closest power of two greater or equal to <code>i</code>.
	 */
	public static int
	nextPowerOfTwo( int i )
	{
		if( i < 2 )
			return 2;

		return (int) Math.pow( 2, (int) log2( i - 1 ) + 1 );
	}

	/**
	 * Is <code>i</code> a power of two?.
	 * @param i The number to test.
	 * @return True if <code>i</code> is a power of two.
	 */
	public static boolean
	isPowerOfTwo( int i )
	{
		double n = ( Math.log( i ) / Math.log( 2.0 ) );	// A complicated way of doing a log2()....

		if( ( n - ((int)n) ) != 0 )
			return false;

		return true;
	}

	/**
	 * Log base 2 of <code>e</code>.
	 * @param e The parameter.
	 * @return The log base 2 of <code>e</code>.
	 */
	public static double
	log2( double e )
	{
		return Math.log( e ) / Math.log( 2.0 );
	}
}
