package book;

/**
 * <h2>Make an object able to be referenced and able to know by who.</h2>
 *
 * @author Antoine Dutot
 * @since 20020615
 * @version 0.1
 */
public interface Referenceable
{
	/**
	 * No more references on this object?.
	 * @return True if there are no more references on this.
	 */
	boolean
	collectable();

	/**
	 * Add a reference to this object.
	 * @param referencer The object that references this.
	 */
	void
	reference( Object referencer );

	/**
	 * Remove a reference to this object.
	 * @param referencer The object that was referencing this.
	 */
	void
	unreference( Object referencer );
}
