package book;

/**
 * <h2>String utilities.</h2>
 *
 * @author Antoine Dutot
 * @since 20030616
 */
public class StringUtils
{
	/**
	 * Remove all white space characters before and after <code>str</code>. If
	 * there are no white spaces at start and at end, <code>str</code> is
	 * returned without modification, else a new string is created.
	 * @param str The string to strip.
	 */
	public static String
	stripSpaces( String str )
	{
		int beg = 0;
		int end = str.length();

		for( int i=0; i<end; ++i )
		{
			if( ! Character.isWhitespace( str.charAt( i ) ) )
			{
				beg = i;
				i   = end;
			}
		}

		if( beg < end )
		{
			for( int i=end-1; i>=beg; --i )
			{
				if( ! Character.isWhitespace( str.charAt( i ) ) )
				{
					end  = i+1;
					i    = beg-1;
				}
			}
		}

		if( beg != 0 || end != str.length() )
			return str.substring( beg, end );

		return str;
	}
}
