package book.geom;

import book.*;

/**
 * <h2>Arbitraty matrix transformation.</h2>
 *
 * @author Antoine Dutot
 * @since 20040516
 */
public class MatrixTransform
	extends
		Matrix4
	implements
		Transform
{
// Constructors

	/**
	 * 
	 */
	private static final long serialVersionUID = -3005140358552481864L;

	/**
	 * Identity matrix.
	 */
	public
	MatrixTransform()
	{
		setIdentity();
	}

	/**
	 * Copy of <code>other</code>.
	 */
	public
	MatrixTransform( Matrix4 other )
	{
		super( other );
	}

	/**
	 * New copy of the 16 components of <code>m16</code> at
	 * <code>offset</code>. <code>m16</code> must have at least
	 * <code>offset</code>+16 cells. order can be {@link #COLUMN_MAJOR} or
	 * {@link #ROW_MAJOR} and indicates how the matrix is stored in
	 * <code>m16</code> ({@link #COLUMN_MAJOR} is the OpenGL convention, {@link
	 * #ROW_MAJOR }is the C and RenderMan convention). See also {@link
	 * #copy(float[],int,int)}.
	 *
	 * @throws InvalidArgumentException If <code>order</code> has an invalid value.
	 * @throws InvalidIndexException If <code>m16</code> has less than
	 * <code>offset</code>+16 cells.
	 */
	public
	MatrixTransform( float[] m16, int offset, int order )
	{
		super( m16, offset, order );
	}
}
