package book.geom;

import java.util.*;

/**
 * <h2>Octree.</h2>
 *
 * @author Antoine Dutot
 * @since 20041005
 */
public class Octree<T>
{
// Attributes

	/**
	 * Maximum number of items per node.
	 */
	protected int maxLoad = 10;

	/**
	 * Root node.
	 */
	protected OctreeNode<T> root;

// Constructors

// Accessors

// Commands

// Nested classes

@SuppressWarnings("hiding")
protected static class OctreeNode<T>
{
// Constants

	//                           X Y Z
	public static final int NODE_0_0_0 = 0;
	public static final int NODE_0_0_1 = 1;
	public static final int NODE_0_1_0 = 2;
	public static final int NODE_0_1_1 = 3;
	public static final int NODE_1_0_0 = 4;
	public static final int NODE_1_0_1 = 5;
	public static final int NODE_1_1_0 = 6;
	public static final int NODE_1_1_1 = 7;

// Attributes

	/**
	 * Left-Bottom-Front point.
	 */
	public Point3 p0;

	/**
	 * Right-Top-Back point.
	 */
	public Point3 p1;

	/**
	 * Elements in the node.
	 */
	public ArrayList<T> items = new ArrayList<T>();

	/**
	 * Sub nodes.
	 */
	public OctreeNode subs[] = new OctreeNode[8];

// Constructors

	public
	OctreeNode()
	{
	}

// Accessors


// Commands

}
}
