package book.geom;

/**
 * <h2>Scale transformation.</h2>
 *
 * <p>A scale is a 3 cell vector indicating the scaleing along the three
 * axis.</p>
 *
 * @author Antoine Dutot
 * @since 20040516
 */
public class ScaleTransform
	extends
		Vector3
	implements
		Transform
{
// Constructors
	
	private static final long serialVersionUID = -2236341016321711934L;

	/**
	 * Null scale (1,1,1).
	 */
	public
	ScaleTransform()
	{
		super( 1, 1, 1 );
	}

	/**
	 * Scale of (<code>sx</code>,<code>sy</code>,<code>sz</code>).
	 */
	public
	ScaleTransform( float sx, float sy, float sz )
	{
		super( sx, sy, sz );
	}
}
