package book.nio;

/**
* <h2>Byte array implementation for CNI.</h2>
 *
 * @author Antoine Dutot
 * @since 20031217
 */
public class ByteDataCni
	extends ByteData
{
// Attributes

	protected byte bb[];

// Constructors

	protected
	ByteDataCni( int count )
	{
		assert( count > 0 );
		bb = new byte[count];
	}

	protected
	ByteDataCni( byte[] data )
	{
		bb = data;
	}

// Accessors

	public Object
	getNative()
	{
		return bb;
	}

	public int
	getCount()
	{
		return bb.length;
	}

	public byte
	get( int i )
	{
		return bb[i];
	}

// Commands

	public void
	set( int i, byte value )
	{
		bb[i] = value;
	}

	public void
	set( int dest_pos, int src_pos, int count, byte values[] )
	{
		System.arraycopy( values, src_pos, bb, dest_pos, count );
	}
}
