package book.nio;

import java.nio.*;

/**
 * <h2>Byte array implementation for a JVM.</h2>
 *
 * @author Antoine Dutot
 * @since 20031217
 */
public class ByteDataJvm
	extends ByteData
{
// Attributes

	protected ByteBuffer bb;

// Constructors

	protected
	ByteDataJvm( int count )
	{
		assert( count > 0 );
		bb = ByteBuffer.allocateDirect( count );
		bb.order( ByteOrder.nativeOrder() );
	}

	protected
	ByteDataJvm( ByteBuffer data )
	{
		bb = data;
	}

// Accessors

	public Object
	getNative()
	{
		return bb;
	}

	public int
	getCount()
	{
		return bb.capacity();
	}

	public byte
	get( int i )
	{
		return bb.get( i );
	}

// Commands

	public void
	set( int i, byte value )
	{
		bb.put( i, value );
	}

	public void
	set( int dest_pos, int src_pos, int count, byte values[] )
	{
		bb.position( dest_pos );
		bb.put( values, src_pos, count );
	}
}
