package book.nio;

/**
* <h2>Double array implementation for CNI.</h2>
 *
 * @author Antoine Dutot
 * @since 20031217
 */
public class DoubleDataCni
	extends DoubleData
{
// Attributes

	protected double bb[];

// Constructors

	protected
	DoubleDataCni( int count )
	{
		assert( count > 0 );
		bb = new double[count];
	}

	protected
	DoubleDataCni( double[] data )
	{
		bb = data;
	}

// Accessors

	public Object
	getNative()
	{
		return bb;
	}

	public int
	getCount()
	{
		return bb.length;
	}

	public double
	get( int i )
	{
		return bb[i];
	}

// Commands

	public void
	set( int i, double value )
	{
		bb[i] = value;
	}

	public void
	set( int dest_pos, int src_pos, int count, double values[] )
	{
		System.arraycopy( values, src_pos, bb, dest_pos, count );
	}
}
