package book.nio;

/**
* <h2>Float array implementation for CNI.</h2>
 *
 * @author Antoine Dutot
 * @since 20031217
 */
public class FloatDataCni
	extends FloatData
{
// Attributes

	protected float bb[];

// Constructors

	protected
	FloatDataCni( int count )
	{
		assert( count > 0 );
		bb = new float[count];
	}

	protected
	FloatDataCni( float[] data )
	{
		bb = data;
	}

// Accessors

	public Object
	getNative()
	{
		return bb;
	}

	public int
	getCount()
	{
		return bb.length;
	}

	public float
	get( int i )
	{
		return bb[i];
	}

// Commands

	public void
	set( int i, float value )
	{
		bb[i] = value;
	}

	public void
	set( int dest_pos, int src_pos, int count, float values[] )
	{
		System.arraycopy( values, src_pos, bb, dest_pos, count );
	}
}
