package book.nio;

/**
* <h2>Int array implementation for CNI.</h2>
 *
 * @author Antoine Dutot
 * @since 20031217
 */
public class IntDataCni
	extends IntData
{
// Attributes

	protected int bb[];

// Constructors

	protected
	IntDataCni( int count )
	{
		assert( count > 0 );
		bb = new int[count];
	}

	protected
	IntDataCni( int[] data )
	{
		bb = data;
	}

// Accessors

	public Object
	getNative()
	{
		return bb;
	}

	public int
	getCount()
	{
		return bb.length;
	}

	public int
	get( int i )
	{
		return bb[i];
	}

// Commands

	public void
	set( int i, int value )
	{
		bb[i] = value;
	}

	public void
	set( int dest_pos, int src_pos, int count, int values[] )
	{
		System.arraycopy( values, src_pos, bb, dest_pos, count );
	}
}
