package book.nio;

import java.nio.*;

/**
 * <h2>Int array implementation for a JVM.</h2>
 *
 * @author Antoine Dutot
 * @since 20031217
 */
public class IntDataJvm
	extends IntData
{
// Attributes

	protected IntBuffer bb;
ByteBuffer b;
// Constructors

	protected
	IntDataJvm( int count )
	{
		assert( count > 0 );
b=ByteBuffer.allocateDirect(count*4);b.order(ByteOrder.nativeOrder());bb=b.asIntBuffer();
	}

	protected
	IntDataJvm( ByteBuffer data )
	{
b=data;bb=b.asIntBuffer();
	}

// Accessors

	public Object
	getNative()
	{
		return b;
	}

	public int
	getCount()
	{
		return bb.capacity();
	}

	public int
	get( int i )
	{
		return bb.get( i );
	}

// Commands

	public void
	set( int i, int value )
	{
		bb.put( i, value );
	}

	public void
	set( int dest_pos, int src_pos, int count, int values[] )
	{
		bb.position( dest_pos );
		bb.put( values, src_pos, count );
	}
}
