package book.nio;

/**
* <h2>Long array implementation for CNI.</h2>
 *
 * @author Antoine Dutot
 * @since 20031217
 */
public class LongDataCni
	extends LongData
{
// Attributes

	protected long bb[];

// Constructors

	protected
	LongDataCni( int count )
	{
		assert( count > 0 );
		bb = new long[count];
	}

	protected
	LongDataCni( long[] data )
	{
		bb = data;
	}

// Accessors

	public Object
	getNative()
	{
		return bb;
	}

	public int
	getCount()
	{
		return bb.length;
	}

	public long
	get( int i )
	{
		return bb[i];
	}

// Commands

	public void
	set( int i, long value )
	{
		bb[i] = value;
	}

	public void
	set( int dest_pos, int src_pos, int count, long values[] )
	{
		System.arraycopy( values, src_pos, bb, dest_pos, count );
	}
}
