package book.nio;

import java.nio.*;

/**
 * <h2>Long array implementation for a JVM.</h2>
 *
 * @author Antoine Dutot
 * @since 20031217
 */
public class LongDataJvm
	extends LongData
{
// Attributes

	protected LongBuffer bb;
ByteBuffer b;
// Constructors

	protected
	LongDataJvm( int count )
	{
		assert( count > 0 );
b=ByteBuffer.allocateDirect(count*8);b.order(ByteOrder.nativeOrder());bb=b.asLongBuffer();
	}

	protected
	LongDataJvm( ByteBuffer data )
	{
b=data;bb=b.asLongBuffer();
	}

// Accessors

	public Object
	getNative()
	{
		return b;
	}

	public int
	getCount()
	{
		return bb.capacity();
	}

	public long
	get( int i )
	{
		return bb.get( i );
	}

// Commands

	public void
	set( int i, long value )
	{
		bb.put( i, value );
	}

	public void
	set( int dest_pos, int src_pos, int count, long values[] )
	{
		bb.position( dest_pos );
		bb.put( values, src_pos, count );
	}
}
