package book.nio;

/**
* <h2>Short array implementation for CNI.</h2>
 *
 * @author Antoine Dutot
 * @since 20031217
 */
public class ShortDataCni
	extends ShortData
{
// Attributes

	protected short bb[];

// Constructors

	protected
	ShortDataCni( int count )
	{
		assert( count > 0 );
		bb = new short[count];
	}

	protected
	ShortDataCni( short[] data )
	{
		bb = data;
	}

// Accessors

	public Object
	getNative()
	{
		return bb;
	}

	public int
	getCount()
	{
		return bb.length;
	}

	public short
	get( int i )
	{
		return bb[i];
	}

// Commands

	public void
	set( int i, short value )
	{
		bb[i] = value;
	}

	public void
	set( int dest_pos, int src_pos, int count, short values[] )
	{
		System.arraycopy( values, src_pos, bb, dest_pos, count );
	}
}
