package book.nio;

import java.nio.*;

/**
 * <h2>Short array implementation for a JVM.</h2>
 *
 * @author Antoine Dutot
 * @since 20031217
 */
public class ShortDataJvm
	extends ShortData
{
// Attributes

	protected ShortBuffer bb;
ByteBuffer b;
// Constructors

	protected
	ShortDataJvm( int count )
	{
		assert( count > 0 );
b=ByteBuffer.allocateDirect(count*2);b.order(ByteOrder.nativeOrder());bb=b.asShortBuffer();
	}

	protected
	ShortDataJvm( ByteBuffer data )
	{
b=data;bb=b.asShortBuffer();
	}

// Accessors

	public Object
	getNative()
	{
		return b;
	}

	public int
	getCount()
	{
		return bb.capacity();
	}

	public short
	get( int i )
	{
		return bb.get( i );
	}

// Commands

	public void
	set( int i, short value )
	{
		bb.put( i, value );
	}

	public void
	set( int dest_pos, int src_pos, int count, short values[] )
	{
		bb.position( dest_pos );
		bb.put( values, src_pos, count );
	}
}
