package book.set;

import java.util.*;

/**
 * Iterator class used to return a non-null iterator even when a collection
 * does not exits.
 *
 * @author Antoine Dutot
 * @since 20040918
 */
public class EmptyIterator<E>
	implements java.util.Iterator<E>
{
	public boolean
	hasNext()
	{
		return false;
	}
	
	public E
	next()
	{
		throw new NoSuchElementException( "empty iterator" );
	}

	public void
	remove()
	{
		throw new IllegalStateException( "no element to remove" );
	}
}
