package book.set;

/**
 * Hash table node.
 *
 * @author Antoine Dutot
 * @since 20000525
 * @version 0.1
 */
public abstract class HashNode
	extends Linkable
{
// Constructors

	/**
	 * New node with no successor.
	 */
	public
	HashNode()
	{
	}
	
	/**
	 * New node linked to successor.
	 */
	public
	HashNode( Linkable successor )
	{
		super( successor );
	}

// Accessors

	/**
	 * New instance of this node with key and value.
	 */
	public abstract HashNode
	new_instance( Object key, Object value ) throws CloneNotSupportedException;

	/**
	 * Does the key of this is considered equal to key?
	 */
	public abstract boolean
	key_equals( Object key );
	
	/**
	 * Hash code for any kind of key. In order to support retrieving nodes from
	 * several kinds of keys(seen as identiqual, for example retrieving a node
	 * whose key is a String using a char[] key), we must provide a method to
	 * return hash codes identiqual for these distinct types of keys.
	 */
	public int
	get_hash_code( Object key )
	{
		return key.hashCode();
	}

	/**
	 * Key stored in this node.
	 */
	public abstract Object
	get_key();

	public abstract Object
	get_value();
}

// vim:ts=4:ai:
