package book.set;

/**
 * Interface for iterators.
 * 
 * @author Antoine Dutot
 * @since 20000620
 * @version 0.1
 */
public interface Iterator
	extends Cloneable
{
// Accessors

	/**
	 * True if no more elements remain.
	 */
	public boolean
	is_end();

	/**
	 * Does other points on the same element as this?
	 */
	public boolean
	equals( Iterator other );

	/**
	 * Value pointed by this iterator or null.
	 */
	public Object
	get_value();

// Commands

	/**
	 * Go to the next element.
	 *
	 * If there is no more elemnts to iterator upon nothing is done. This means
	 * that the iterator does no restart at its begining.
	 */
	public void
	next();
}

// vim:ts=4:ai:
