package book.set;

/**
 * Boubly linked node with an `Object' value.
 *
 * @author Antoine Dutot
 * @since 19991022
 * @version 0.1
 */
public class ObjectBilinkable
	extends Bilinkable
{
// Attributes

	/**
	 * Contents of the node.
	 */
	public Object value;
	
// Constuctors

	/**
	 * New node with no predecessor nor successor.
	 */
	public
	ObjectBilinkable()
	{
	}

	/**
	 * New node pointing on predecessor and on successor.
	 */
	public
	ObjectBilinkable( Bilinkable predecessor, Bilinkable successor )
	{
		super( predecessor, successor );
	}
	
	/**
	 * New node with value pointing on predecessor and on successor.
	 */
	public
	ObjectBilinkable( Object value, Bilinkable predecessor, Bilinkable successor )
	{
		super( predecessor, successor );
		this.value = value;
	}
	
	/**
	 * New node with value and no predecessor nor successor.
	 */
	public
	ObjectBilinkable( Object value )
	{
		super();
		this.value = value;
	}

// Accessors

	/**
	 * Value of this node.
	 */
	public Object
	get_value()
	{
		return value;
	}

// Commands

	/**
	 * Change the value.
	 */
	public void
	set_value( Object value )
	{
		this.value = value;
	}
	
	/**
	 * Swap this with other.
	 */
	public void
	swap( ObjectBilinkable other )
	{
		super.swap( other );
		Object t;

		t = value;
		value = other.value;
		other.value = t;
	}
}

// vim:ts=4:ai:
