package book.set;

/**
 * Default node type for the Hash class.
 *
 * @author Antoine Dutot
 * @since 20010212
 * @version 0.1
 */
public class ObjectHashNode
	extends HashNode
	implements Cloneable
{
// Attributes

	/**
	 * Key for the node.
	 */
	public Object key;

	/**
	 * Value for the node.
	 */
	public Object value;

// Constructors

	/**
	 * New node with no successor.
	 */
	public
	ObjectHashNode()
	{
		super();
	}
	
	/**
	 * New node key containing object linked to successor.
	 */
	public
	ObjectHashNode( Object key, Object value, Linkable successor )
	{
		super( successor );
		this.key = key;
		this.value = value;
	}
	
	/**
	 * New node key containing object with no successor.
	 */
	public
	ObjectHashNode( Object key, Object value )
	{
		super();
		this.key = key;
		this.value = value;
	}

// Accessors
	
	public HashNode
	new_instance( Object key, Object value ) throws CloneNotSupportedException
	{
		return new ObjectHashNode( key, value );
	}

	public boolean
	key_equals( Object key )
	{
		return( this.key.equals( key ) );
	}

	/**
	 * Hash code for any kind of key.
	 */
	public int
	get_hash_code( Object key )
	{
		return key.hashCode();
	}

	public Object
	get_key()
	{
		return key;
	}

	public Object
	get_value()
	{
		return value;
	}

// Commands

	/**
	 * Change the key.
	 */
	public void
	set_key( Object key )
	{
		this.key = key;
	}

	/**
	 * Change the value.
	 */
	public void
	set_value( Object value )
	{
		this.value = value;
	}
}

// vim:ts=4:ai:
