package book.set;


/**
 * Singly linked node with an Object value.
 *
 * @author Antoine Dutot
 * @since 19991022
 * @version 0.1
 */
public class ObjectLinkable
	extends Linkable
{
// Attributes

	/**
	 * Contents of the node.
	 */
	public Object value;

// Constuctors

	/**
	 * New node pointing on nothing.
	 */
	public
	ObjectLinkable()
	{
	}

	/**
	 * New node pointing on successor.
	 */
	public
	ObjectLinkable( Linkable successor )
	{
		super( successor );
	}
	
	/**
	 * New node with value pointing on successor.
	 */
	public
	ObjectLinkable( Object value, Linkable successor )
	{
		super( successor );
		this.value = value;
	}

// Accessors

	/**
	 * Value of this node.
	 */
	public Object
	get_value()
	{
		return value;
	}
	
// Commands

	/**
	 * Change the value.
	 */
	public void
	set_value( Object value )
	{
		this.value = value;
	}
	
	/**
	 * Swap this with other.
	 */
	public void
	swap( ObjectLinkable other )
	{
		super.swap( other );
		Object t;

		t = value;
		value = other.value;
		other.value = t;
	}
}

// vim:ts=4:ai:
