package book.tests;

import book.set.FixedArrayList;

/**
 * TestFixedArrayList.
 *
 * @author Antoine Dutot
 * @since 20040914
 */
public class TestFixedArrayList
{
	public static final void
	main( String args[] )
	{
		new TestFixedArrayList();
	}

	public
	TestFixedArrayList()
	{
		FixedArrayList<String> array = new FixedArrayList<String>();

		assert( array.size() == 0 );

		boolean ok = false;

		array.add( "toto" );		assert array.size() == 1 : "size after insert";
		int toto = array.getLastIndex();

		array.add( "tutu" );		assert array.size() == 2 : "size after insert";
		int tutu = array.getLastIndex();

		array.add( "titi" );		assert array.size() == 3 : "size after insert";
		int titi = array.getLastIndex();

		array.add( "tata" );		assert array.size() == 4 : "size after insert";
		int tata = array.getLastIndex();

		assert array.get( toto ).equals( "toto" ) : "access";
		assert array.get( tutu ).equals( "tutu" ) : "access";
		assert array.get( titi ).equals( "titi" ) : "access";
		assert array.get( tata ).equals( "tata" ) : "access";

		array.remove( toto );	assert( array.size() == 3 );
		
		try
		{
			array.get( toto );
		}
		catch( Exception e )
		{
			ok = true;
		}

		assert ok : "access non existing element";

		ok = false;

		try
		{
			array.remove( toto );
		}
		catch( Exception e )
		{
			ok = true;
		}

		assert ok : "removing non existing element";

		array.clear();

		assert array.size() == 0 : "clear";
	}
}
