package embeddings.dictionary;

import java.util.HashMap;
import java.util.Map;

public class Dictionary {
	private Map<String, Integer> relations2ID;
	private Map<Integer, String> id2Relations;
	private int relCount;

	public Dictionary() {
		relations2ID = new HashMap<String, Integer>();
		id2Relations = new HashMap<Integer, String>();
	}

	public Dictionary(Map<String, Integer> relations2id, Map<Integer, String> id2Relations) {
		this.relations2ID = relations2id;
		this.id2Relations = id2Relations;
		this.relCount = id2Relations.size();
	}

	public void addRelation(String relToBeAdded) {
		if (!relations2ID.containsKey(relToBeAdded)) {
			relations2ID.put(relToBeAdded, relCount);
			id2Relations.put(relCount, relToBeAdded);
			relCount++;
		}
	}

	public Map<String, Integer> getRelations2ID() {
		return relations2ID;
	}

	public void setRelations2ID(Map<String, Integer> relations2id) {
		relations2ID = relations2id;
	}

	public Map<Integer, String> getId2Relations() {
		return id2Relations;
	}

	public void setId2Relations(Map<Integer, String> id2Relations) {
		this.id2Relations = id2Relations;
	}

	public int getRelCount() {
		return relCount;
	}

	public void setRelCount(int relCount) {
		this.relCount = relCount;
	}

}
