package graph_search.modes;

import java.util.List;

import org.apache.jena.rdf.model.Resource;

import embeddings.dictionary.Dictionary;
import fact_check.query.QueryExecutioner;
import graph_search.Matrix;

/**
 * Doesn't care at all for domain and range consistency, thus all bits are set.
 *
 */
public class IrrelevantDR extends Matrix {
	
	public IrrelevantDR() {
	}

	public IrrelevantDR(QueryExecutioner sparqlExec, Dictionary dictionary) {
		super(sparqlExec, dictionary);
	}

	@Override
	public boolean compareSets(List<Resource> a, List<Resource> b) {
		return true;
	}
	
	@Override
	public String toString() {
		return "Irrelevant";
	}
}
