package graph_search.modes;

import java.util.Collections;
import java.util.List;

import org.apache.jena.rdf.model.Resource;

import embeddings.dictionary.Dictionary;
import fact_check.query.QueryExecutioner;
import graph_search.Matrix;

/**
 * If it has at least one element in common 
 *
 */
public class NotDisjointDR extends Matrix {
	
	public NotDisjointDR() {
	}
	
	public NotDisjointDR(QueryExecutioner sparqlExec, Dictionary dictionary) {
		super(sparqlExec, dictionary);
	}
	
	@Override
	public boolean compareSets(List<Resource> a, List<Resource> b) {
		return !Collections.disjoint(a, b);
	}
	
	@Override
	public String toString() {
		return "Non-disjoint";
	}
}
