package graph_search.modes;

import java.util.List;

import org.apache.jena.rdf.model.Resource;

import embeddings.dictionary.Dictionary;
import fact_check.query.QueryExecutioner;
import graph_search.Matrix;

/**
 * The domain and range of other paths have to match exactly the one of the
 * given predicate. Both sets need to contain exactly the same elements
 *
 */
public class StrictDR extends Matrix {
	
	public StrictDR() {
	}

	public StrictDR(QueryExecutioner sparqlExec, Dictionary dictionary) {
		super(sparqlExec, dictionary);
	}

	@Override
	public boolean compareSets(List<Resource> a, List<Resource> b) {
		return a.equals(b);
	}
	
	@Override
	public String toString() {
		return "Strict";
	}
	
}
