/////////////////////////////////////////////////////////////////////////////////////////
// 
//                 Université de Nice Sophia-Antipolis  (UNS) - 
//                 Centre National de la Recherche Scientifique (CNRS)
//                 Copyright © 2015 UNS, CNRS All Rights Reserved.
// 
//     These computer program listings and specifications, herein, are
//     the property of Université de Nice Sophia-Antipolis and CNRS
//     shall not be reproduced or copied or used in whole or in part as
//     the basis for manufacture or sale of items without written permission.
//     For a license agreement, please contact:
//     <mailto: licensing@sattse.com> 
//
//
//
//     Author: Luc Hogie – Laboratoire I3S - luc.hogie@unice.fr
//
//////////////////////////////////////////////////////////////////////////////////////////

 
 package octojus.perf;


public abstract class PerformanceMetric
{
	public long computeNumberOfTurnsInDuration(long durationMs)
	{
		long numberOfTurns = 0;
		long start = System.currentTimeMillis();

		// while the stress duration has not yet expired
		while (System.currentTimeMillis() - start < durationMs)
		{
			// do something heavy
			oneTurn();
			++numberOfTurns;
		}

		return numberOfTurns;
	}

	protected abstract void oneTurn();
}
