package org.miv.graphstream.examples.esm08;

import java.io.IOException;

import org.miv.graphstream.graph.Graph;
import org.miv.graphstream.graph.implementations.DefaultGraph;
import org.miv.graphstream.io.DynamicGraphWriterHelper;
import org.miv.graphstream.io.GraphParseException;
import org.miv.graphstream.io.GraphReader;
import org.miv.graphstream.io.GraphReaderDGS;
import org.miv.graphstream.io.GraphReaderListenerHelper;

public class Tutorial2c {
	public static void main( String args[] ) {
		new Tutorial2c();
	}
	public Tutorial2c() {
        try {
        	Graph graph = new DefaultGraph();
        	DynamicGraphWriterHelper writer = new DynamicGraphWriterHelper();
           	writer.begin( graph, "mygraph.dgs" );
        	graph.display( false );
            GraphReader reader = new GraphReaderDGS();
        	reader.addGraphReaderListener( new GraphReaderListenerHelper( graph ) );
        	System.out.printf( "Please, enter some DGS line :%n" );
        	reader.begin( System.in );
        	while( true ) {
        		try {
        			reader.nextEvents();
        			writer.flush();
        			System.out.printf( "* Read one event !%n" );
        		} catch( GraphParseException e ) {
        			System.err.printf( "I do not understand that ! (%s)%n", e.getMessage() );
        		}
        	}
        } catch( GraphParseException e ) {
        	e.printStackTrace();
        	System.exit(1);
        } catch( IOException e ) {
	        e.printStackTrace();
        	System.exit(1);
        }
	}
}