/*
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package org.miv.graphstream.ui2.swing.test;

import java.io.IOException;

import org.miv.graphstream.graph.Graph;
import org.miv.graphstream.graph.implementations.MultiGraph;
import org.miv.graphstream.io.GraphParseException;
import org.miv.graphstream.ui.swing.SwingGraphViewer;
import org.miv.util.NotFoundException;

public class TestLargeGraphOld
{
	public static void main( String args[] )
	{
		try
		{
			new TestLargeGraphOld();
		}
		catch( Exception e )
		{
			e.printStackTrace();
		}
	}
	
	public TestLargeGraphOld() throws NotFoundException, IOException, GraphParseException
	{
		Graph graph = new MultiGraph( "LeHavre" );

		graph.read( "/home/antoine/Recherche/Media/Graphs/Michel/LeHavre.dgs" );
		graph.addAttribute( "ui.stylesheet", styleSheet );
		
		SwingGraphViewer viewer = new SwingGraphViewer( graph, null, false, false );
		viewer.setQuality( 1 );
	}
	
	protected static final String styleSheet = 
		"node { width: 2px; }" +
		"edge { color: grey; }";
}