/*
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package org.miv.graphstream.ui2.swing.test;

import org.miv.graphstream.graph.Graph;
import org.miv.graphstream.graph.Node;
import org.miv.graphstream.graph.implementations.MultiGraph;
import org.miv.graphstream.ui2.swing.SwingGraphViewer;

public class TestSwingViewer
{
	public static void main( String args[] )
	{
		new TestSwingViewer();
	}
	
	public TestSwingViewer()
	{
		Graph graph = new MultiGraph( "Test !" );
		
		graph.addAttribute( "ui.stylesheet", styleSheet );
		
		Node A = graph.addNode( "A" );
		Node B = graph.addNode( "B" );
		Node C = graph.addNode( "C" );
		
		graph.addEdge( "AB", "A", "B" );
		graph.addEdge( "BC", "B", "C" );
		graph.addEdge( "CA", "C", "A" );
		
		A.setAttribute( "xy",  0,  1 );
		B.setAttribute( "xy", -1, -1 );
		C.setAttribute( "xy",  2, -2 );
		
		SwingGraphViewer viewer = new SwingGraphViewer( graph, null, false, false );
		
		viewer.setModeFPS( true );
	}
	
	protected static String styleSheet =
		"graph { padding: 30px; }";
}