/* (C) Copyright 2009-2013 CNRS (Centre National de la Recherche Scientifique).

Licensed to the CNRS under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The CNRS licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.

*/

/* Contributors:

Luc Hogie (CNRS, I3S laboratory, University of Nice-Sophia Antipolis) 

*/
 
 
package oscilloscup;



import java.util.Collection;
import java.util.Vector;

import javax.swing.JFrame;

import oscilloscup.data.Figure;
import oscilloscup.data.Point;
import oscilloscup.data.math.Function;
import oscilloscup.data.rendering.point.CirclePointRenderer;

public class Test
{
    public static void main(String[] args)
    {
        new Test();
    }
    
    public Test()
    {
        Collection<Double> xList = new Vector<Double>();

        for (double x = 0; x < 10; x += 0.1d)
        {
            xList.add(x);
        }

        Function f = new Function()
        {

            @Override
            public Point evaluate(double d)
            {
                return new Point(d, Math.cos(d) * Math.sin(d) * Math.tan(d));
            }
            
        };
        f.setDefinitionValues(0, 10, 0.1);
        Figure figure = f.createFigure();
        figure.addRenderer(new CirclePointRenderer());

        SwingPlotter plotter = new SwingPlotter();
        plotter.getGraphics2DPlotter().setFigure(figure);

        
        JFrame frame = new JFrame("y = f(x)");
        frame.setContentPane(plotter);
        frame.setSize(800, 600);
        frame.setVisible(true);
    }
    
}
