/* (C) Copyright 2009-2013 CNRS (Centre National de la Recherche Scientifique).

Licensed to the CNRS under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The CNRS licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.

*/

/* Contributors:

Luc Hogie (CNRS, I3S laboratory, University of Nice-Sophia Antipolis) 

*/
 
 
package oscilloscup.data;



import java.awt.Color;
import java.util.List;
import java.util.Vector;

import oscilloscup.data.rendering.figure.ConnectedLineFigureRenderer;
import oscilloscup.data.rendering.figure.FigureRenderer;

/*
 * Created on Dec 30, 2004
 */

/**
 * @author luc.hogie
 */
public class CurveSet extends Figure
{
	private List renderers = new Vector();
	
	public CurveSet()
	{
		{
			ConnectedLineFigureRenderer r = new ConnectedLineFigureRenderer();
			r.setColor(Color.blue);
			renderers.add(r);
		}
		{
			ConnectedLineFigureRenderer r = new ConnectedLineFigureRenderer();
			r.setColor(Color.red);
			renderers.add(r);
		}
		{
			ConnectedLineFigureRenderer r = new ConnectedLineFigureRenderer();
			r.setColor(Color.green);
			renderers.add(r);
		}
		{
			ConnectedLineFigureRenderer r = new ConnectedLineFigureRenderer();
			r.setColor(Color.black);
			renderers.add(r);
		}
	}
	
	
	public void addFigure(Figure figure)
	{
		super.addFigure(figure);
		figure.addRenderer((FigureRenderer) renderers.get(getFigureCount() - 1));
	}
	
	public void addPoint(Point p)
	{
		throw new IllegalStateException("only figures can be added");
	}
}
