package toools.io;

import java.io.IOException;
import java.io.InputStream;
import java.util.Iterator;

import toools.io.file.RegularFile;

public abstract class FileIterator<E> implements Iterator<E>
{
	protected final InputStream unbufferredInputStream;

	public FileIterator(RegularFile f)
	{
		unbufferredInputStream = f.createReadingStream(0);
	}

	public void close()
	{
		try
		{
			unbufferredInputStream.close();
		}
		catch (IOException e)
		{
			throw new IllegalStateException(e);
		}
	}
}
