package toools.io.file.nbs;

import java.io.IOException;

import it.unimi.dsi.fastutil.longs.LongIterator;
import toools.io.BinaryReader;
import toools.io.FileIterator;

public class NBSFileIterator extends FileIterator<Long> implements LongIterator
{
	private long index;
	private final BinaryReader b;
	private final long endIndex;
	private final int encoding;

	public NBSFileIterator(NBSFile f, long startEntry) throws IOException
	{
		super(f);
		this.index = startEntry;
		this.encoding = unbufferredInputStream.read();
		this.endIndex = (f.getSize() - 1) / encoding;
		unbufferredInputStream.skip(startEntry * encoding);
		b = new BinaryReader(unbufferredInputStream, 65536 * 256);
	}

	public int getEncoding()
	{
		return encoding;
	}

	@Override
	public boolean hasNext()
	{
		return index < endIndex;
	}

	@Override
	public long nextLong()
	{
		++index;
		return b.next(encoding);
	}
}
