package toools.io.file.nbs;

import java.io.IOException;
import java.io.OutputStream;

import toools.io.Bits;
import toools.io.IORuntimeException;

public class NBSWriter
{
	private final OutputStream os;
	private final byte[] b;
	private int encoding;

	public NBSWriter(OutputStream os, int encoding)
	{
		this.os = os;
		this.encoding = encoding;
		b = new byte[encoding];

		try
		{
			os.write(encoding);
		}
		catch (IOException e)
		{
			throw new IORuntimeException(e);
		}
	}

	public void write(long value)
	{
		try
		{
			Bits.putLong(b, 0, value, encoding);
			os.write(b);
		}
		catch (IOException e)
		{
			throw new IORuntimeException(e);
		}
	}

	public void close()
	{
		try
		{
			os.close();
		}
		catch (IOException e)
		{
			throw new IORuntimeException(e);
		}
	}
}
