package toools.io.file.nbs;

import java.io.IOException;

import toools.io.Cout;
import toools.progression.LongProcess;

public class concat
{
	public static void main(String[] args) throws IOException
	{
		Info info = findEncoding(args);
		NBSFile destFile = new NBSFile(args[args.length - 1]);
		NBSWriter w = new NBSWriter(destFile.createWritingStream(false, 1000000),
				info.encoding);
		LongProcess l = new LongProcess("concatenating " + info.nbEntries + " entries from "
				+ (args.length - 1) + " files", " element", info.nbEntries);

		for (int i = 0; i < args.length - 1; ++i)
		{
			NBSFile f = new NBSFile(args[i]);
			Cout.progress("processing " + f);
			NBSFileIterator it = f.iterator();

			while (it.hasNext())
			{
				w.write(it.nextLong());
				++l.sensor.progressStatus;
			}
		}

		l.end();
		w.close();
	}

	private static class Info
	{
		int encoding = 0;
		long nbEntries = 0;
	}

	private static Info findEncoding(String[] args)
	{
		LongProcess ana = new LongProcess("analysing " +  (args.length - 1) + " files", " file", args.length - 1);
		
		Info r = new Info();

		for (int i = 0; i < args.length - 1; ++i)
		{
			NBSFile f = new NBSFile(args[i]);
			r.encoding = Math.max(r.encoding, f.readEncoding());
			r.nbEntries += f.getNbValues();
			++ana.sensor.progressStatus;
		}

		ana.end();
		return r;
	}
}
