package toools.io.file.nbs;

import java.io.IOException;

import it.unimi.dsi.fastutil.longs.Long2LongAVLTreeMap;
import it.unimi.dsi.fastutil.longs.Long2LongMap;
import toools.io.Cout;
import toools.io.file.RegularFile;
import toools.progression.LongProcess;
import toools.text.CSV;

public class distribution
{
	public static void main(String[] args) throws IOException
	{
		NBSFile inputFile = new NBSFile(args[0]);
		long nbInput = Long.valueOf(args[1]);
		RegularFile destFile = null;

		destFile = new RegularFile(args[2]);

		Long2LongMap m = new Long2LongAVLTreeMap();

		LongProcess computing = new LongProcess(
				"computing distribution of file " + inputFile, " number",
				inputFile.getNbValues());

		NBSFileIterator iterator = inputFile.iterator();
		int i = 0;

		while (iterator.hasNext())
		{
			long l = iterator.nextLong();
			long n = m.getOrDefault(l, 0);
			m.put(l, n + 1);
			++computing.sensor.progressStatus;

			if (++i == nbInput)
				break;
		}

		computing.end();
		LongProcess writing = new LongProcess("writing " + destFile, null, - 1);
		destFile.setContent(CSV.from(m).getBytes());

		long sum = 0;
		for (Long o : m.values())
		{
			sum += o;
		}

		Cout.debugSuperVisible("sum=" + sum);

		writing.end();
	}
}
